import RPi.GPIO as GPIO
import time

GPIO.setmode(GPIO.BCM)

def readData(channel):
  # read SPI data from MCP3008 chip, 8 possible adc channels (0 thru 7)
  # this function was written by Limor "Ladyada" Fried
  # for Adafruit Industries, (c) 2015
  if ((channel > 7) or (channel < 0)):
    return -1
  GPIO.output(cs, True)
  GPIO.output(clk, False) # start clock low
  GPIO.output(cs, False)  # bring CS low

  command = channel
  command |= 0x18       # start bit + single-ended bit
  command <<= 3         # we only need to send 5 bits here

  for i in range(5):
    if (command & 0x80):
      GPIO.output(din, True)
    else:
      GPIO.output(din, False)
    command <<= 1
    GPIO.output(clk, True)
    GPIO.output(clk, False)

  adcout = 0
  # read in one empty bit, one null bit and 10 ADC bits
  for i in range(12):
    GPIO.output(clk, True)
    GPIO.output(clk, False)
    adcout <<= 1
    if (GPIO.input(dout)):
      adcout |= 0x1

  GPIO.output(cs, True)
        
  adcout >>= 1       # first bit is 'null' so drop it
  return adcout
# end readData()

# Pin-Belegung:
clk = 18
dout = 23
din = 24
cs = 25

GPIO.setup(clk, GPIO.OUT)
GPIO.setup(cs, GPIO.OUT)
GPIO.setup(din, GPIO.OUT)
GPIO.setup(dout, GPIO.IN)

print ("Strg+C beendet das Programm")
try:
  while True:
    potValue = readData(0)
    print(potValue)
    time.sleep(0.1)
except KeyboardInterrupt:
  GPIO.cleanup()
